/*
 * swo_log.h
 *
 * Created on: 20.01.2025
 * Author: Kilian
 *
 * Compatibility header for the new logging system
 * This allows existing code to continue using swo_log.h without modifications
 */
#pragma once
#ifndef __SWO_LOG_H
#define __SWO_LOG_H

#ifdef SWO_LOG_PREFIX
#define LOG_PREFIX SWO_LOG_PREFIX
#endif

#include "log.h"
#include "swo_log_backend.h"

/* For backward compatibility with existing code */
#define debug_log log_message
#define debug_log_cont log_message_cont
#define debug_clear_console log_clear_console

#define DEBUG_CHANNEL_ENABLED(level) log_is_level_enabled(level)

/* All actual functionality is now in log.h and swo_log_backend.h */

#endif /* __SWO_LOG_H */
